/* Author: kurt.stephens@parlano.com 2000/10/05 */
/*   parlano eventloop library -- pl_el/callback.h
 *   Copyright (C) 2001 Parlano, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _pl_cb_h
#define _pl_cb_h

/* Reuseable callback list manager. */

struct pl_cb;
typedef struct pl_cb pl_cb;

#define pl_cb_handler_DECL(X) int X (void *data1, void *data2, void *handle)
typedef pl_cb_handler_DECL((*pl_cb_handler));

enum {
  pl_cb_ONESHOT = 0,
  pl_cb_REPEAT = 1
};


struct pl_cb {
  /*@ Callback list and entry. */

  pl_cb *next;
  /*@ Next entry. */

  pl_cb *prev;
  /*@ Prev entry. */

  pl_cb_handler func;
  /*@ Callback function. */

  void *data2;
  /*@ Callback function argument. */
  
  int flags;
  /*@ pl_cb_REPEAT, ... */
};


int pl_cb_init(pl_cb *cbl);
int pl_cb_destroy(pl_cb *cbl);

void * pl_cb_add(pl_cb *cbl, pl_cb_handler func, void *data2, int flags);
int    pl_cb_remove(void *handle);

int pl_cb_all(pl_cb *cbl, void *data1);

#endif
