/*   parlano eventloop library -- pl_el/dlinklist.h
 *   Copyright (C) 2001 Parlano, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _pl_DLINKLIST_H
#define _pl_DLINKLIST_H

/* Author: kurt.stephens@parlano.com 2000/09/25 */

/* Doubly-linked list macros. */

#define pl_dll_INIT(X) ((X)->next = (X)->prev = (X))

#define pl_dll_BEGIN(X) ((X)->next)

#define pl_dll_END(X) (X)

#define pl_dll_INSERT_BEFORE(X,Y) \
( \
  (X)->next = (Y), \
  (X)->prev = (Y)->prev, \
  (Y)->prev->next = (X), \
  (Y)->prev = (X) \
  )

#define pl_dll_REMOVE(X) ((X)->prev->next = (X)->next, (X)->next->prev = (X)->prev, pl_dll_INIT(X))

#endif
