/* Author: kurt.stephens@parlano.com 2000/10/09 */
/*   parlano eventloop library -- pl_el/timeval.h
 *   Copyright (C) 2001 Parlano, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _pl_TIMEVAL_H_
#define _pl_TIMEVAL_H_

#include <time.h>
#include <sys/time.h>
#include <unistd.h>

struct timeval pl_timeval_now();

struct timeval pl_double_to_timeval(double t);
double pl_timeval_to_double(struct timeval t);

struct timeval pl_time_t_to_timeval(time_t t);
time_t pl_timeval_to_time_t(struct timeval t);

int pl_timeval_cmp(struct timeval x, struct timeval y);
struct timeval pl_timeval_sub(struct timeval x, struct timeval y);
struct timeval pl_timeval_add(struct timeval x, struct timeval y);

#endif
